#include "date.h"
void calendar_date(DATE jdate, int* day, int* month, int* year)
/* Calculate the day, month, and year corresponding to a Julian date number */
/* The year will be negative if it is B.C. 				    */
{
	long a, b, c, d, e, z, alpha;
	z = jdate + 1;
	/* Cope with Gregorian calendar reform */
	if ( z < 2299161L)
		a = z;
	else
	{
		alpha = (long) ((z - 1867216.25) / 36524.25);
		a = z + 1 + alpha - alpha / 4;
	}
	b = a + 1524;
	c = (long) ((b - 122.1) / 365.25);
	d = (long) (365.25 * c);
	e = (long) ((b - d) / 30.6001);
	*day = (int) b - d - (long) (30.6001 * e);
	*month = (int) (e < 13.5) ? e - 1 : e - 13;
	*year = (int) (*month > 2.5) ? (c - 4716) : c - 4715;
}