 #include "date.h"
 #include <stdio.h>

 void month_calendar(int month, int year) 
 
 /* Print a calendar for the specified month. */ 
 
 { DATE b_date, e_date, c_date; int day, c_day, c_month, c_year;

 /* Calculate Julian day numbers for first and last days of the month. */
 b_date = julian_date(1, month, year);

 if (month < 12)
	e_date = julian_date(1, month + 1, year) - 1;
 else
	e_date = julian_date(1, 1, year + 1) - 1;

 printf("%2d/%d:\n\n", month, year);
 printf("SUN MON TUE WED THU FRI SAT\n\n");

 /* Put first day of month under the correct day column. */
 for (day = 1; day < day_of_week(b_date); day++)
	printf(" ");

 /* Print all the days */
 for (c_date = b_date; c_date <= e_date; c_date++)
 {
	calendar_date(c_date, &c_day, &c_month, &c_year);
	printf("%3u ", c_day);

 if (day_of_week(c_date) == 7)
	printf("\n");
 }

 /* If Easter happens this month, print the date. */
 if ((year >= 0) && (easter(year) >= b_date && easter(year) <= e_date))
 {
	calendar_date(easter(year), &c_day, &c_month, &c_year);
	printf("\n\nEaster: %2d/%2d", c_month, c_day);
 }

 printf("\n\n\n");
}
