
/****************************************************************************

  OS/2 Command Line Editor/Retriever

  This is a partial main program for the command line editor/retriever. It
  installs an associated DLL to replace a KBD routine. See documentation
  for details of its use.

  Author: William E. Ives
  Date	: November 18, 1988  first working version
	  December 19, 1988  added profile capabilities
****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>

#define INCL_BASE
#define INCL_DOSPROCESS
#include <os2.h>

#define TRUE 1
#define FALSE 0

/* external DLL routine prototypes */
void far pascal InitVioKbd( int nattr, int hattr );
void far pascal TermVioKbd( void );

char childarg[200];  /* argument to chlid process array. */


main( int argc, char * argv[] )
{
 char	achFailName[128];
 RESULTCODES rescResults;
 USHORT  retcode ;
 char far * childname ;
 char far * aptr ;
 int	    i ;
 SEL	    sel ;

 printf("\n OS/2 Command Editor/Retriever 1.0 \n");
 printf(" Copyright (c) 1989 by William Ives\n");

 if ( argc < 2 ) {
    puts(" Usage :de <full name of cmd processor> [args to cmd proc]");
    return;
    }

 i=1 ;

 childname=  (char far *) argv[i] ;

 /* construct the child argument array */
 aptr = (char far *) childarg ;
 if ( argc > (i+1) ) {
    retcode=TRUE;
    for (;i<argc;i++) {
	strcpy( aptr, argv[i] );
	aptr += strlen(argv[i]);
	if ( retcode) { aptr++; retcode=FALSE; }
	else	   *aptr++=' ';
	}
    *aptr=0; /* put in double NULL terminator */
    }


 /* Save Vio & Kbd state */
 InitVioKbd( 0x17,0x7 );

 /* Register our kbdstringin routine */
 if ( retcode=KbdRegister((PSZ)"dedll",(PSZ)"_INPUTSTRING",(ULONG)KR_KBDSTRINGIN ) ){
    printf(" Unable to register new KbdStringIn %d\n",retcode);
    return;
    }

 /* spawn the command processor */

 if ( argc <= 2 )
   retcode =  DosExecPgm( achFailName, sizeof(achFailName),EXEC_SYNC,
			NULL,NULL,&rescResults,childname);
 else
   retcode =  DosExecPgm( achFailName, sizeof(achFailName),EXEC_SYNC,
			(PSZ)childarg,NULL,&rescResults,childname);

 if ( retcode ) {
    printf(" Error %d while executing command processor.\n",retcode);
    puts(" Usage :de <full name of cmd processor> [args to cmd proc]");
    }

 /* Restore vio & kbd state */
 TermVioKbd();
 /* Uninstall the kbdstringin routine */
 KbdDeRegister();

} /* main */

