#include "date.h" 
 
DATE easter(int year) 
 
 /* Calculate the Julian day number of Easter for the 
    specified year, which cannot be negative. 
 */ 
{ 
 int a, b, c, d, e, f, g, h, i, k, l, m, n, p, day, month; 
 
 if (year >= 1583) 
 { 
 /* Calculate date of Easter for a year in the Gregorian calendar. */ 
 	a = year % 19; 
	b = year / 100; 
	c = year % 100; 
	d = b / 4; 
	e = b % 4; 
	f = (b + 8) / 25; 
	g = (b - f + 1) / 3; 
	h = (19 * a + b - d - g + 15) % 30; 
	i = c / 4; k = c % 4; 
	l = (32 + 2 * e + 2 * i - h - k) % 7; 
	m = (a + 11 * h + 22 * l) / 451; 
	n = (h + l - 7 * m + 114) / 31; 
	p = (h + l - 7 * m + 114) % 31;
	
	month = n; 
	day = p + 1; 
 } 
 else 
 { 
 /* Calculate date of Easter for a year in the Julian calendar. */ 
 	a = year % 4; 
	b = year % 7; 
	c = year % 19; 
	d = (19 * c + 15) % 30;
	e = (2 * a + 4 * b - d + 34) % 7; 
	f = (d + e + 114) / 31; 
	g = (d + e + 114) % 31; 

	month = f; 
	day = g + 1; 
 } 
 return julian_date(day, month, year); 
} 
 
