#include "date.h"
  
DATE julian_date(int day, int month, int year)
/* Calculate the Julian day number for the specified day, month, and year */
/* If the year is B.C., it should be passed in as negative       */
{
    int   a,b;
    float year_corr;
    /* Correct for negative year */
	 year_corr = (year > 0 ? 0.0 : 0.75);
    if (month <= 2)
    {
        year--;
        month += 12;
    }
    b = 0;
    /* Cope with the Gregorian calendar reforms */
    if (year * 10000.0 + month * 100.0 + day >= 15821015.0)
    {
        a = year / 100;
        b = 2 - a + a / 4;
    }
    return (DATE) (long) (365.25 * year - year_corr) +
	 (long) (30.6001 * (month + 1)) + day + 1720994L + b;
}
