#include "date.h" 
 
int valid_date(int day, int month, int year) 
 
 /* Validate the specified day, month, and year. 
 
    For example, the following dates are not valid: 
 
    February 29, 1973 (not a leap year ) April 31 (April has only 30 days) 
 */ 
{ 
 	int cal_day, cal_month, cal_year; 
 
 	/* Convert date to Julian day number and back. */
	calendar_date(julian_date(day, month, year), &cal_day, &cal_month, &cal_year); 

	/* Date is valid if day, month, and year did not change. */ 
	return ((day == cal_day) && (month == cal_month) && (year == cal_year)); 
} 
